#include <iostream>
#include <SDL.h>
#include <SDL_image.h>

const int SCREEN_WIDTH = 800;
const int SCREEN_HEIGTH = 600;

using namespace std;

int collides(SDL_Rect &a, SDL_Rect &b)
{
  if ((a.x + a.w > b.x && b.x > a.x) || (b.x + b.w > a.x && a.x > b.x)) {
    if ((a.y + a.h > b.y && b.y > a.y) || (b.y + b.h > a.y && a.y > b.y)) {
      return 1;
    }
  }
  return 0;
}


int main(int argc, char *argv[])
{
  SDL_Surface *screen;

  if (SDL_Init(SDL_INIT_VIDEO /*|SDL_INIT_AUDIO*/) == -1) {
    cout << "Error initializing SDL" << endl;
  }

  screen = SDL_SetVideoMode(SCREEN_WIDTH, SCREEN_HEIGTH, 32, SDL_SWSURFACE|SDL_DOUBLEBUF);

  if (screen == NULL) {
    cout << "Error " << endl;
  }

  SDL_Surface *blue;
  blue = IMG_Load("blue.png");

  int blue_width = blue->w;
  int blue_heigth = blue->h;

  SDL_Surface *green = IMG_Load("green.png");


  SDL_Rect ball_rect;
  ball_rect.x = 5;
  ball_rect.y = 5;
  ball_rect.w = blue_width;
  ball_rect.h = blue_heigth;
  int xspeed = 10, yspeed = 10;

  SDL_Rect mouse_rect;
  mouse_rect.x = 0;
  mouse_rect.y = 0;
  mouse_rect.w = blue_width;
  mouse_rect.h = blue_heigth;
  

  int running = 1;
  while (running) {
    SDL_FillRect(screen, NULL, 0x000000);


    SDL_Event ev;

    while (SDL_PollEvent(&ev)) {
      if (ev.type == SDL_KEYDOWN) {
	if (ev.key.keysym.sym == SDLK_ESCAPE) {
	  running = 0;

	} else if (ev.key.keysym.sym == SDLK_x) {
	  xspeed = -xspeed;

	} else if (ev.key.keysym.sym == SDLK_y) {
	  yspeed = -yspeed;
	}
      } else if (ev.type == SDL_MOUSEMOTION) {
	mouse_rect.x = ev.motion.x - (blue_width/2);
	mouse_rect.y = ev.motion.y - (blue_heigth/2);
	SDL_BlitSurface(green, NULL, screen, &mouse_rect);
	
      } else if (ev.type == SDL_MOUSEBUTTONDOWN) {
	ball_rect.x = ev.button.x;
	ball_rect.y = ev.button.y;
      }
    }

    if(collides(mouse_rect, ball_rect)) {
      xspeed = -xspeed;
      yspeed = -yspeed;
    }

    ball_rect.x += xspeed;
    ball_rect.y += yspeed;

    if (ball_rect.x + blue_width > SCREEN_WIDTH || ball_rect.x < 0) {
      xspeed = -xspeed;
    }

    if (ball_rect.y + blue_heigth > SCREEN_HEIGTH || ball_rect.y < 0) {
      yspeed = -yspeed;
    }

    SDL_BlitSurface(blue, NULL, screen, &ball_rect);

    SDL_Flip(screen);

    SDL_Delay(10);
  }

  SDL_FreeSurface(blue);

  SDL_Quit();
  
  return 0;
}
